import { CloverAction } from "gap-nodejs-sdk/dist/clover/enums";
import { PaymentResponseModel } from "gap-nodejs-sdk/dist/clover/payment_response_model";
export class CloverUsbPaymentResponseModel extends PaymentResponseModel {
    static build(data) {
        console.log(data);
        let paymentResponse = new PaymentResponseModel();
        if (data.Success) {
            paymentResponse.status = PaymentResponseModel.STATUS_OK;
            paymentResponse.statusCode = PaymentResponseModel.STATUS_CODE_OK;
        }
        else {
            paymentResponse.status = PaymentResponseModel.STATUS_FAIL;
            paymentResponse.statusCode = PaymentResponseModel.STATUS_CODE_FAIL;
        }
        paymentResponse.statusMessage = data.Message;
        paymentResponse.data = data.Payment || null;
        switch (data.type) {
            case 'sale':
                paymentResponse.action = CloverAction.ACTION_CLOVER_SALE_RESPONSE;
                if (data.Payment) {
                    paymentResponse.refID = data.Payment.id;
                    paymentResponse.approveAmount = data.Payment.amount;
                }
                break;
            case 'auth':
                paymentResponse.action = CloverAction.ACTION_CLOVER_AUTH_RESPONSE;
                if (data.Payment) {
                    paymentResponse.refID = data.Payment.id;
                    paymentResponse.approveAmount = data.Payment.amount;
                }
                break;
            case 'adjust':
                paymentResponse.action = CloverAction.ACTION_CLOVER_ADJUST_RESPONSE;
                if (data.Payment) {
                    paymentResponse.refID = data.Payment.id;
                }
                break;
            case 'void':
                paymentResponse.action = CloverAction.ACTION_CLOVER_VOID_RESPONSE;
                if (data.Reason == "REJECT_PARTIAL_AUTH") {
                    paymentResponse.action = CloverAction.ACTION_CLOVER_CANCEL_TRANSACTION_WITH_DUE_AMOUNT;
                }
                if (data.Payment) {
                    paymentResponse.refID = data.Payment.id;
                }
                break;
            case 'refund':
                paymentResponse.action = CloverAction.ACTION_CLOVER_RETURN_RESPONSE;
                if (data.Payment) {
                    paymentResponse.refID = data.Payment.id;
                }
                break;
            case 'batch_close':
                paymentResponse.action = CloverAction.ACTION_CLOVER_BATCH_CLOSE_RESPONSE;
                paymentResponse.data = data.Batch || null;
                break;
            case 'retrieve':
                paymentResponse.action = CloverAction.ACTION_CLOVER_RETRIEVE_PAYMENT_RESPONSE;
                if (data.Payment) {
                    paymentResponse.refID = data.Payment.id;
                }
                break;
        }
        return paymentResponse;
    }
}
